#include <windows.h>
#include <winnt.h>
#include <stdio.h>

IMAGE_NT_HEADERS *(__stdcall * _CheckSumMappedFile)(void*,DWORD,DWORD*,DWORD*) = 0;

void process(char *filename)
{
   printf("processing %s... ", filename);
   FILE *ff = fopen(filename, "rb");
   if (!ff) { printf("file not found\n"); return; }
   fseek(ff, 0, SEEK_END);
   unsigned size = ftell(ff); rewind(ff);

   char *data = (char*)malloc(size);
   if (!data) { printf("out of memory!"); exit(2); }

   fread(data, 1, size, ff);
   fclose(ff);

   static const unsigned tab1[] = { 1,0, 3,2, 5,4, 2,7  };
   static const unsigned tab2[] = { 1,0, 5,4, 9,8, 2,13 };

   int done = 0;
   for (unsigned i = 0; i < size - sizeof tab1; i+=4)
      if (!memcmp(data+i, tab1, sizeof tab1))
         memcpy(data+i, tab2, sizeof tab2), done++;

   if (done) {
      ff = fopen(filename, "wb");
      if (ff) {
         if (_CheckSumMappedFile) {
            DWORD csum, oldsum;
            IMAGE_NT_HEADERS *nt_header = _CheckSumMappedFile(data, size, &oldsum, &csum);
            if (nt_header) nt_header->OptionalHeader.CheckSum = csum;
         }
         fwrite(data, 1, size, ff);
         fclose(ff); printf("bug fixed\n");
      } else printf("file write error\n");
   } else printf("bug#08 not found\n");

   free(data);
}


void __cdecl main()
{
   printf("bugfix for UnrealSpeccy' bug#08 by SMT\n\n");

   HMODULE dll = LoadLibrary("imagehlp.dll");
   if (dll) _CheckSumMappedFile =
      (IMAGE_NT_HEADERS *(__stdcall *)(void*,DWORD,DWORD*,DWORD*))
        GetProcAddress(dll, "CheckSumMappedFile");

   process("unreal_p6.exe");
   process("unreal_p5.exe");
   process("unrelite.exe");

   if (dll) FreeLibrary(dll);
}
