#include <windows.h>
#include <winnt.h>
#include <stdio.h>

IMAGE_NT_HEADERS *(__stdcall * _CheckSumMappedFile)(void*,DWORD,DWORD*,DWORD*) = 0;

void process(char *filename)
{
   printf("processing %s... ", filename);
   FILE *ff = fopen(filename, "rb");
   if (!ff) { printf("file not found\n"); return; }
   fseek(ff, 0, SEEK_END);
   unsigned size = ftell(ff); rewind(ff);

   char *data = (char*)malloc(size);
   if (!data) { printf("out of memory!"); exit(2); }

   fread(data, 1, size, ff);
   fclose(ff);

   int done = 0;
   for (unsigned i = 0; i < size - 4; i++)
      if (*(unsigned*)(data+i) == 3500000*18/10)
         *(unsigned*)(data+i) = 3500000*2, done=1;

   if (done) {
      ff = fopen(filename, "wb");
      if (ff) {
         if (_CheckSumMappedFile) {
            DWORD csum, oldsum;
            IMAGE_NT_HEADERS *nt_header = _CheckSumMappedFile(data, size, &oldsum, &csum);
            if (nt_header) nt_header->OptionalHeader.CheckSum = csum;
         }
         fwrite(data, 1, size, ff);
         fclose(ff); printf("bug fixed\n");
      } else printf("file write error\n");
   } else printf("bug#15 not found\n");

   free(data);
}


void __cdecl main()
{
   printf("bugfix for UnrealSpeccy' bug#15 by SMT\n\n");

   HMODULE dll = LoadLibrary("imagehlp.dll");
   if (dll) _CheckSumMappedFile =
      (IMAGE_NT_HEADERS *(__stdcall *)(void*,DWORD,DWORD*,DWORD*))
        GetProcAddress(dll, "CheckSumMappedFile");

   process("unreal_p6.exe");
   process("unreal_p5.exe");
   process("unrelite.exe");

   if (dll) FreeLibrary(dll);
}
